<?php
define('CONFIG_PATH', dirname(__FILE__) . DIRECTORY_SEPARATOR);
define('CONFIG_PROJECTS_FILE', CONFIG_PATH . 'projects.txt');
define('CONFIG_LOG_FILE', CONFIG_PATH . 'log.txt');

define('CONFIG_LINUX', !isWin());
define('CONFIG_WINDOWS_PATH_PHP', 'Z:\usr\local\php5\php.exe');

define('CONFIG_BASEPATH', '/var/www/server_dev/data/');
define('CONFIG_DEFAULT_REPOSITORIES', CONFIG_BASEPATH . 'repositories/'); //gitolite repos
define('CONFIG_DEFAULT_CONTENTS', CONFIG_BASEPATH . 'www/git.intsystem.org/'); //path to live versions

define('CONFIG_REMOTE_REPO', 'ssh://server_dev@server-dev-local/');


define('CODE_ERROR_ARGUMENTS', 1);
define('CODE_ERROR_FILE_PROJECTS', 130);
define('CODE_ERROR_PROJECT_NOT_FOUND', 140);
define('CODE_ERROR_PATH_NOT_FOUND', 150);

error_reporting(0);

function isWin()
{
	return DIRECTORY_SEPARATOR == '\\';
}

function LogAdd($log_str)
{
	$log_str = str_replace("\n", '\n', $log_str);
	$log_str = str_replace("\r", '\r', $log_str);
	$log_str = str_replace("\0", '\0', $log_str);

	file_put_contents(CONFIG_LOG_FILE, "[" . date("Y-m-d H:i:s") . "] " . $log_str . "\n", FILE_APPEND);
}

function OutError($error_text, $error_code = null)
{
	if (strlen($error_text) > 0) {
		fwrite(STDERR, 'Error: ' . $error_text . "\n");
	}

	if (!is_null($error_code)) {
		exit($error_code);
	}

	return false;
}

function MakePath($path, $type)
{
	if (substr($path, 0, 1) == '/') {
		//Ничего не делаем
	} elseif ($type == 'content' || $type == 'contents') {
		$path = CONFIG_DEFAULT_CONTENTS . $path;
	} elseif ($type == 'repository' || $type == 'repositories') {
		if (substr($path, -4, 4) != '.git') {
			$path = CONFIG_DEFAULT_REPOSITORIES . $path . '.git';
		} else {
			$path = CONFIG_DEFAULT_REPOSITORIES . $path;
		}
	}

	if (DIRECTORY_SEPARATOR == '/') {
		$path	 = str_replace('\\', DIRECTORY_SEPARATOR, $path);
		$path	 = preg_replace('#\/+#i', DIRECTORY_SEPARATOR, $path);
	} else {
		$path	 = str_replace('/', DIRECTORY_SEPARATOR, $path);
		$path	 = preg_replace('#\\\\+#i', DIRECTORY_SEPARATOR, $path);
	}

	if (substr($path, -1, 1) != DIRECTORY_SEPARATOR) {
		$path = $path . DIRECTORY_SEPARATOR;
	}

	return $path;
}
