#!/usr/bin/php
<?php
include(dirname(__FILE__).'/config.php');


if($argc!==4){
	LogAdd('HookGit: Missing parameters');
	OutError("Missing parameters. Need three arguments, such as: script.php '[pwd]' '[repo_base]' '[repo_name]'", CODE_ERROR_ARGUMENTS);
}

$input=array(
	'pwd' => $argv[1],
	'base' => $argv[2],
	'name' => $argv[3],
);

LogAdd('HookGit: Arguments '.json_encode($input));

if(CONFIG_LINUX){
	$exec_str=CONFIG_PATH.'find_project.php';
}else{
	$exec_str=CONFIG_WINDOWS_PATH_PHP.' -f "'.CONFIG_PATH.'find_project.php" -- -f';
}

$result_path='';
$exec_ret=255;

//Поиск нужного репозитория и папки с dev версией сайта
if($result_path==''){
	$exec_result=exec($exec_str.' -o content -i repository -v '.escapeshellarg($input['pwd']).'', $exec_arr, $exec_ret);

	if($exec_ret==0){
		$result_path=$exec_result;
	}
}

if($result_path==''){
	$exec_result=exec($exec_str.' -o content -i name -v '.escapeshellarg($input['name']).'', $exec_arr, $exec_ret);

	if($exec_ret==0){
		$result_path=$exec_result;
	}
}

if($result_path==''){
	$exec_result=exec($exec_str.' -o content -i repository -v '.escapeshellarg($input['base'].DIRECTORY_SEPARATOR.$input['name']).'', $exec_arr, $exec_ret);

	if($exec_ret==0){
		$result_path=$exec_result;
	}
}

if($result_path==''){
	LogAdd('HookGit: Can not find the required project');
	OutError("Can not find the required project", CODE_ERROR_PROJECT_NOT_FOUND);
}else{
	LogAdd('HookGit: Project found, resulted path: '.$result_path);
}


//Работа с репозиторием в папке с dev сайтом
if(!file_exists($result_path)){
	LogAdd('HookGit: Project found, but resulted path does not exist');
	OutError("Project found, but resulted path does not exist", CODE_ERROR_PATH_NOT_FOUND);
}


function execBash($command)
{
	ob_start();
	exec($command, $content);
	$contents = ob_get_contents();
	ob_end_clean();
	
	return implode("\n", $content);
}

if(!file_exists($result_path.'.git/')){
	//Клонируем новый репозиторий
	$cmd = '
LAST_DIR=`pwd`

cd '.escapeshellarg($result_path).'

if [ `pwd` = "'.rtrim($result_path, DIRECTORY_SEPARATOR).'" ];
then
  rm -rf ./*
  find '.$result_path.' -name ".*" -exec rm -rf {} \;

  git clone '.CONFIG_REMOTE_REPO.''.escapeshellarg($input['name']).'.git ./
fi

cd $LAST_DIR
';

	$content = execBash($cmd);

	LogAdd('HookGit: Clone status: '.$content);
	LogAdd('HookGit: Repository cloned');
}else{
	//Получем изменения
	$cmd ='
LAST_DIR=`pwd`

cd '.escapeshellarg($result_path).'

REPO_DIR=`pwd`

if [ `pwd` = "'.rtrim($result_path, DIRECTORY_SEPARATOR).'" ];
then
  export GIT_DIR="$REPO_DIR/.git"

  git fetch --all

  git reset --hard origin/master
fi

cd $LAST_DIR
';

	$content = execBash($cmd);

	LogAdd('HookGit: Reset status: '.$content);
	LogAdd('HookGit: Repository reseted');
}
